var features = {};

/*** array addons */

function arrayContains(array,value)
{
    for ( var i = 0, length = array.length; i < length; i++ )
	if (array[i] == value) return true;
    return false;
}

/*** DOM */

function nodeClass(node)
{
    if (!node) return "";
    return node.getAttribute('className') || node.getAttribute('class');
}

function nodeFindByName(lst,name)
{
	for(var i =0;i<lst.length;++i)
		if (lst[i].getAttribute('name') == name)
			return lst[i];
	return null;
}

function nodeFindByNameValue(lst,name,value)
{
	for(var i =0;i<lst.length;++i)
		if (lst[i].getAttribute('name') == name &&
		    lst[i].getAttribute('value') == value)
			return lst[i];
	return null;
}

/* ajax updating */

function updateInputs(page)
{
    $('input[type=text],input[type=hidden]').each(function(i)
	{
	    var elt = $('input[name='+this.name+'][type='+this.type+']',page);
	    if (elt.length && elt.attr('value') != undefined)
		this.defaultValue = this.value = elt.attr('value');
	});
    $('input[type=checkbox]').each(function(i)
	{
	    var elt = $('input[name='+this.name+'][value='+this.value+'][type=checkbox]',page);
	    if (elt.length)
		this.defaultChecked = this.checked = elt.attr('checked')?true:false;
	});
}

function updateTextAreas(page)
{
    $('textarea').each(function(i)
	{
	    var elt = $('textarea[name='+this.name+']',page);
	    if (elt.length)
		this.defaultValue = this.value = elt.text();
	});
}

function updateSpans(page)
{
    $('span[class=alterator-label]').each(function(i)
	{
	    var self =$(this);
	    var elt = $('span[class=alterator-label][name='+self.attr('name')+']',page);
	    if (elt.length)
		self.text(elt.text());
	});
}

function updateSelects(page)
{
    function makeOption(text,value,selected)
    {
	var item = document.createElement('option');
	item.text = text;
	item.value = value;
	item.defaultSelected = item.selected = selected?true:false;

	return item;
    }

    $('select').each(function(i)
	{
	    var self = $(this);
	    var elt = $('select[name='+self.attr('name')+']',page);

	    if (elt.length == 0) return;

	    self.empty();

	    $('option',elt).each(function(j)
		{
		    var self2 = $(this);
		    var v = self2.attr('value');
		    var s = self2.attr('selected');
		    var t = self2.text();

		    self.append(makeOption(t,v,s));
		});
	});
}
